package  
{
	import org.flixel.*;
	
	/**
	 * ...
	 * @author Nathan McCoy
	 */
	public class Particle extends FlxSprite 
	{
		public static const SMOKE:int = 0;
		public static const EMBER:int = 1;
		public static const DEBRIS:int = 2;
		public static const MAGIC:int = 3;
		public static const RAIN:int = 4;
		public static const WATER:int = 5;
		
		
		
				
		[Embed(source = "../lib/smoke.png")]
		private var smokeImg:Class;
		
		[Embed(source = "../lib/ember.png")]
		private var emberImg:Class;
		[Embed(source = "../lib/transmutesplash.png")]
		private var magicImg:Class;
		[Embed(source = "../lib/watersparkle.png")]
		private var waterImg:Class;
		
		
		[Embed(source = "../lib/tileset.png")]
		private static var tiles:Class;
		
		private static var tilesprite:FlxSprite = new FlxSprite(0, 0, tiles);
		
		private var kind:int;
		
		public function Particle() 
		{
			super();
			addAnimation("smoke", new Array(0, 1, 2, 3), 7, false);
			addAnimation("ember", new Array(0, 1, 2, 3, 4, 5, 6, 7), 20, false);
			addAnimation("magic", new Array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9), 30, false);
			addAnimation("water", new Array(0, 1, 2, 3, 4, 5, 6, 7, 8), 10, false);
			
		}
		public function init(nx:Number, ny:Number, type:int, tile:int = 0):void
		{
			exists = true;
			acceleration.x = 0;
			acceleration.y = 0;
			velocity.x = 0;
			velocity.y = 0;
			drag.x = 0;
			drag.y = 0;
			flicker(0);
			
			kind = type;
			
			switch(type)
			{
				case SMOKE:
					loadGraphic(smokeImg, true);
					play("smoke", true);
					velocity.x = Math.random() * 20 - 10;
					velocity.y = Math.random() * 20 - 10;
					acceleration.y = -30;
					color = 0xFFDDDDDD;
					break;
				case EMBER:
					loadGraphic(emberImg, true);
					play("smoke", true);
					velocity.x = Math.random() * 10 - 5;
					velocity.y = Math.random() * 10 - 5;
					acceleration.y = -30;
					color = 0xFFFFFFFF;
					break;
				case DEBRIS:
					makeGraphic(3, 3, 0x00FFFFFF);
					stamp(tilesprite, -tile * 8 - Math.random() * 6, -Math.random() * 6);
					velocity.x = Math.random() * 60 - 30;
					velocity.y = -Math.random() * 50;
					acceleration.y = 150;
					flicker(1);
					break;
				case MAGIC:
					loadGraphic(magicImg, true);
					play("magic", true);
					color = 0xFFFFFFFF;
					break;
				case RAIN:
					makeGraphic(1, 4, 0xFF3273ff);
					color = 0xFFFFFFFF;
					velocity.x = 0;
					velocity.y = 200 + Math.random() * 200;
					break;
				case WATER:
					loadGraphic(waterImg, true);
					play("water", true);
					color = 0xFFFFFFFF;
					break;
					
				default:
					break;
			}
			x = nx - width/2;
			y = ny - height/2;
		}
		public override function update():void
		{
			if (kind == SMOKE) velocity.x += Math.random() * 6 - 3;
			
			super.update();
			if (kind == DEBRIS)
			{
				if (!flickering) exists = false;
			}
			else if (kind == RAIN)
			{
				if (y > FlxG.height) exists = false;
			}
			else if(finished) exists = false;
		}
	}

}