package
{

	import org.flixel.*;
	import org.flixel.system.FlxTile;
	import org.flixel.plugin.photonstorm.*;
	
	
	public class PlayState extends FlxState
	{
		[Embed(source = "../lib/map.csv", mimeType="application/octet-stream")]
		private var levelone:Class;
		
		[Embed(source = "../lib/tileset.png")]
		private var tiles:Class;
		[Embed(source = "../lib/cursor.png")]
		private var cursorImg:Class;
		[Embed(source = "../lib/sun.png")]
		private var sunImg:Class;
		[Embed(source = "../lib/moon.png")]
		private var moonImg:Class;
		[Embed(source = "../lib/stars.png")]
		private var starsImg:Class;
		
		[Embed(source = "../lib/horizon.png")]
		private var horizonImg:Class;
		
		
		
		
		[Embed(source = "../lib/pickup.mp3")]
		private var grabSound:Class;
		[Embed(source = "../lib/drop.mp3")]
		private var dropSound:Class;
		[Embed(source = "../lib/ouch.mp3")]
		private var ouchSound:Class;
		[Embed(source = "../lib/slam.mp3")]
		private var slamSound:Class;
		[Embed(source = "../lib/charged.mp3")]
		private var chargedSound:Class;
		[Embed(source = "../lib/alchemy.mp3")]
		private var alchemySound:Class;
		[Embed(source = "../lib/leaves.mp3")]
		private var leavesSound:Class;
		[Embed(source = "../lib/dawn.mp3")]
		private var dawnSound:Class;
		[Embed(source = "../lib/rain.mp3")]
		private var rainSound:Class;
		[Embed(source = "../lib/glassbreak.mp3")]
		private var glassSound:Class;
		
		
		
		[Embed(source = "../lib/beats.mp3")]
		private var beatsMusic:Class;
		[Embed(source = "../lib/beatless.mp3")]
		private var beatlessMusic:Class;
		[Embed(source = "../lib/twilight.mp3")]
		private var twiMusic:Class;
		[Embed(source = "../lib/nightmelody.mp3")]
		private var nightMusic:Class;
		
		
		
		
		public var rhythm:FlxSound;
		public var tunes:FlxSound;
		public var twilightmusic:FlxSound;
		public var night:FlxSound;
		
		
		private var rainticks:int;
		
		
				
		
				
		
		public var map:FlxTilemap;
		public var avatar:PlayerSprite;
		public var cursor:FlxSprite;
		public var carried:FlxSprite;
		public var sun:FlxSprite;
		public var moon:FlxSprite;
		public var stars:FlxSprite;
		public var rain_overlay:FlxSprite;
		
		public var horizon:FlxSprite;
		
		
		public var carryText:FlxText;
		public var titleText:FlxText;
		public var infoText:FlxText;
		
		
		public var grabFrom:FlxPoint;
		public var grab_frames:int;
		public static const MAX_GRAB_FRAMES:int = 4;
		public static const MAX_CHARGE_FRAMES:int = 60;
		
		public var dayframes:int;
		public static const DAY_LENGTH:int = 60 * 90;
		public var carrying:int;
		
		public var charging:Boolean;
		public var charge_time:int;
		
		public var raining:Boolean;
		
		public var particles:FlxGroup;
		//                                          0          1       2        3        4        5       6         7          8       9               10       11       12       13              14              15       16               17            18               19      20     21
		public const TILE_NAMES:Array = new Array( "Nothing", "Dirt", "Grass", "Stone", "Metal", "Wood", "Leaves", "Volcano", "Seed", "Planted Soil", "Water", "Crate", "Chest", "Empty Bottle", "Water Bottle", "Cloud", "Planted Cloud", "Sky Leaves", "Potion Bottle", "Gold", "Key", "Victory Diamond" );
		public static const NOTHING:int = 0, DIRT:int = 1, GRASS:int = 2, STONE:int = 3, METAL:int = 4, WOOD:int = 5, 
		LEAVES:int = 6, VOLCANO:int = 7, SEED:int = 8, PLANTED_SOIL:int = 9, WATER:int = 10, 
		CRATE:int = 11, CHEST:int = 12, EMPTY_BOTTLE:int = 13, WATER_BOTTLE:int = 14, CLOUD:int = 15,
		PLANTED_CLOUD:int = 16, SKY_LEAVES:int = 17, POTION_BOTTLE:int = 18, GOLD:int=19, KEY:int = 20, DIAMOND:int = 21;
		
		override public function create():void
		{
			rhythm = new FlxSound();
			tunes = new FlxSound();
			twilightmusic = new FlxSound();
			night = new FlxSound();
			
			rhythm.volume = 0;
			twilightmusic.volume = 0;
			night.volume = 0;
			
			rhythm.loadEmbedded(beatsMusic, true);
			tunes.loadEmbedded(beatlessMusic, true);
			twilightmusic.loadEmbedded(twiMusic, true);
			night.loadEmbedded(nightMusic, true);
			
			
			rhythm.play();
			tunes.play();
			twilightmusic.play();
			night.play();
			
			
			
			horizon = new FlxSprite(0, 0, horizonImg);
			add(horizon);
			stars = new FlxSprite(0, 0, starsImg);
			//add(stars);
			sun = new FlxSprite(0, 0, sunImg);
			add(sun);
			moon = new FlxSprite(0, 0, moonImg);
			add(moon);
			
			map = new FlxTilemap();
			map.loadMap(new levelone, tiles);
			map.setTileProperties(7, 0x1111, volcanoTouch, PlayerSprite, 1);
			map.setTileProperties(10, 0x0000);
			map.setTileProperties(CLOUD, 0x0100);
			map.setTileProperties(PLANTED_CLOUD, 0x0100);
			
			FlxG.bgColor = 0xFF22CCFF;
			
			avatar = new PlayerSprite(FlxG.width / 2 - 8, 60);
			add(avatar);
			add(map);
			avatar.width -= 2;
			avatar.offset.x += 1;
			
			
			carried = new FlxSprite();
			carried.loadGraphic(tiles, true);
			add(carried);		
			
			rain_overlay = new FlxSprite();
			rain_overlay.makeGraphic(FlxG.width, FlxG.height, 0x448888AA);
			add(rain_overlay);
			
			particles = new FlxGroup();
			add(particles);
			
			cursor = new FlxSprite();
			cursor.loadGraphic(cursorImg, true);
			cursor.alpha = 0.5;
			add(cursor);
			carrying = 0;
			
			carryText = new FlxText(4, FlxG.height - 15, FlxG.width, TILE_NAMES[carrying]);
			carryText.alpha = 0.5;
			add(carryText);
			
			titleText = new FlxText(4, 2, FlxG.width, "Atom Planet               by Nathan McCoy");
			titleText.alpha = 0.8;
			add(titleText);
			
			infoText = new FlxText(120, 105, FlxG.width, "arrows move\nX = grab/drop\nhold X for slam\nZ/Y/W = jump");
			infoText.alpha = 0.8;
			add(infoText);
			
			
			
			
			grabFrom = new FlxPoint();
			FlxG.mouse.hide();
			
			dayframes = DAY_LENGTH / 8;
			rainticks = 0;
		}
		
		public function progressDay():void
		{
			dayframes++;
			sun.x = FlxG.width / 2 + FlxG.height / 3 * Math.cos(dayframes * Math.PI * 2 / DAY_LENGTH) - sun.width/2;
			sun.y = FlxG.height / 2 + FlxG.height / 3 * -Math.sin(dayframes * Math.PI * 2 / DAY_LENGTH) - sun.height/2;
			
			moon.x = FlxG.width / 2 + FlxG.height / 3 * Math.cos(dayframes * Math.PI * 2 / DAY_LENGTH + Math.PI) - moon.width/2;
			moon.y = FlxG.height / 2 + FlxG.height / 3 * -Math.sin(dayframes * Math.PI * 2 / DAY_LENGTH + Math.PI) - moon.height/2;
			
			
			var sunAltitude:Number = Math.sin(dayframes * Math.PI * 2 / DAY_LENGTH);
			sunAltitude *= 3;
			if (sunAltitude > 1) sunAltitude = 1;
			if (sunAltitude < -1) sunAltitude = -1;
			
			rhythm.volume = Math.max(sunAltitude, 0);
			night.volume = Math.max(-sunAltitude, 0);
			
			
			moon.alpha = -sunAltitude + 1;
			sun.alpha = sunAltitude + 1;
			
			stars.alpha = -sunAltitude;
			
			var sunHeight:int = int((sunAltitude / 2 + 0.5) * 255);
			var twilight:int = int((1 - sunAltitude * sunAltitude) * 255);
			
			twilightmusic.volume = (1 - sunAltitude * sunAltitude) / 2;
			
			horizon.color = FlxColor.interpolateColor(0xFF1A0088, 0xFF66EEFF, 255, sunHeight, 255);
			horizon.color = FlxColor.interpolateColor(horizon.color, 0xFFFFCC00, 255, twilight, 255);
			
			FlxG.bgColor = FlxColor.interpolateColor(0xFF0A0022, 0xFF00AAFF, 255, sunHeight, 255);
			if (dayframes >= DAY_LENGTH) 
			{
				dayframes = 0;
				doDailyStuff();
			}
			if (dayframes == DAY_LENGTH / 2) doDailyStuff();
			if ((dayframes + DAY_LENGTH / 8) % (DAY_LENGTH / 4) == 0) 
			{
				rainticks++;
				raining = false;
				if (Math.random() * 4 < 1 || rainticks == 1) raining = true;
			}
			if (raining)
			{
				rain_overlay.alpha += 0.03;
			}
			else rain_overlay.alpha -= 0.03;
		}
		
		public function tryGrowingTree(mx:int, my:int):Boolean
		{
			var leaf_type:int = LEAVES;
			if (map.getTile(mx, my) == PLANTED_CLOUD) leaf_type = SKY_LEAVES;
			var success:Boolean;
			success = (map.getTile(mx, my - 1) == 0 &&
						    map.getTile(mx, my - 2) == 0 &&
							map.getTile(mx, my - 3) == 0 &&
							map.getTile(mx, my - 4) == 0 &&
							map.getTile(mx - 1, my - 3) == 0 &&
							map.getTile(mx + 1, my - 3) == 0);
						
						if (my < 4) success = false;
						if(success)
						{
							if (leaf_type == SKY_LEAVES)
								map.setTile(mx, my, CLOUD);
							else map.setTile(mx, my, 1);
							map.setTile(mx, my - 1, 5);
							map.setTile(mx, my - 2, 5);
							map.setTile(mx, my - 3, leaf_type);
							map.setTile(mx, my - 4, leaf_type);
							map.setTile(mx+1, my - 3, leaf_type);
							map.setTile(mx-1, my - 3, leaf_type);
						}
						return success;
		}
		
		public function doDailyStuff():void
		{
			FlxG.flash(0xFFFFFFFF,1,null, true);
			FlxG.play(dawnSound, 0.2);
			var indices:Array = new Array;
			titleText.alpha = 0.15;
			infoText.alpha = 0.15;
			
				
			//grow new grass
			for (mx = 0; mx < map.widthInTiles;	mx++)
				for (my = 0; my < map.heightInTiles;	my++)
				{
					if (map.getTile(mx, my) == 1 && map.getTile(mx, my - 1) == 0 && 
					(map.getTile(mx - 1, my) == 2 || map.getTile(mx - 1, my + 1) == 2 || map.getTile(mx - 1, my - 1) == 2 ||
					 map.getTile(mx + 1, my) == 2 || map.getTile(mx + 1, my + 1) == 2 || map.getTile(mx + 1, my -1) == 2))
					indices.push(my * map.widthInTiles + mx);
				}
			while(indices.length > 0)
			{
				map.setTileByIndex(indices.pop(), 2);
			}
			
			//clouds evaporate unless they have two cloud neighbors
			
			for (mx = 0; mx < map.widthInTiles;	mx++)
				for (my = 0; my < map.heightInTiles;	my++)
				{
					if (map.getTile(mx, my) == CLOUD || map.getTile(mx, my) == PLANTED_CLOUD)
					{
						var neigh:int = 0;
						if (map.getTile(mx + 1, my) == CLOUD || map.getTile(mx + 1, my) == PLANTED_CLOUD) neigh++;
						if (map.getTile(mx - 1, my) == CLOUD || map.getTile(mx - 1, my) == PLANTED_CLOUD) neigh++;
						if (map.getTile(mx, my + 1) == CLOUD || map.getTile(mx, my + 1) == PLANTED_CLOUD) neigh++;
						if (map.getTile(mx, my - 1) == CLOUD || map.getTile(mx, my - 1) == PLANTED_CLOUD) neigh++;
						if (neigh < 2) indices.push(mx + my * map.widthInTiles);
					}
				}
			while(indices.length > 0)
			{
				map.setTileByIndex(indices.pop(), NOTHING);
			}
			
			//Volcano cooks things
			for (mx = 0; mx < map.widthInTiles;	mx++)
				for (my = 0; my < map.heightInTiles;	my++)
				{
					if (map.getTile(mx, my) == VOLCANO)
					{
						var top:int = map.getTile(mx, my - 1);
						if (top == WOOD || top == LEAVES || top == SEED || top == CRATE || top == SKY_LEAVES)
						{
							smashTile(mx, my-1);
							map.setTile(mx, my-1, NOTHING);
							for (var i:int = 0; i < 15; i++)
								addParticle(mx * 8 + Math.random() * 8, (my-1) * 8 + Math.random() * 8, Particle.EMBER);
							for (i = 0; i < 8; i++)
								addParticle(mx * 8 + Math.random() * 8, (my-1) * 8 + Math.random() * 8, Particle.SMOKE);
							
							FlxG.play(slamSound);
							if(top == CRATE) map.setTile(mx, my-1, EMPTY_BOTTLE);
						}
						if (top == WATER_BOTTLE && map.getTile(mx, my-2) == NOTHING)
						{
							map.setTile(mx, my - 1, EMPTY_BOTTLE);
							map.setTile(mx, my - 2, CLOUD);
						}
					}
				}		
			
			
			//unconfined water evaporates
			var startRange:int = -1;
			for (my = map.heightInTiles - 1; my >= 0;	my--)
			{
				for (mx = 0; mx < map.widthInTiles;	mx++)
				{
					if (map.getTile(mx, my) == WATER)
					{
						indices.push(mx + my * map.widthInTiles);
						if ((map.getTile(mx - 1, my) == 0 || map.getTile(mx + 1, my) == 0 || map.getTile(mx, my + 1) == 0))
						{
							while (indices.length > 0)
								map.setTileByIndex(indices.pop(), 0);
						}
					}
					else indices.splice(0);
				}
			}	
			
			//kill suffocated grass
			for (var mx:int = 0; mx < map.widthInTiles;	mx++)
				for (var my:int = 0; my < map.heightInTiles;	my++)
				{
					if (map.getTile(mx, my) == GRASS && map.getTile(mx, my - 1) != 0) map.setTile(mx, my, 1);
				}
				
			//Flood when raining
			if (raining)
			{
				startRange = -1;
				for (my = map.heightInTiles-1; my >= 0;	my--)
				{
					for (mx = 0; mx < map.widthInTiles;	mx++)
					{
						if (map.getTile(mx, my) != 0 && startRange != -1)
						{
							for (i = startRange; i < mx; i++) indices.push(my * map.widthInTiles + i);
							startRange = -1;
						}
						if (map.getTile(mx, my) == 0 && map.getTile(mx - 1, my) != 0 && map.getTile(mx, my + 1) != 0)
							startRange = mx;
						if (map.getTile(mx, my+1) == 0)
						 startRange = -1;
					}
					startRange = -1;
				}
				
				while (indices.length > 0)
					map.setTileByIndex(indices.pop(), 10);
			}
			
			//grow trees
			for (mx = 0; mx < map.widthInTiles;	mx++)
				for (my = 0; my < map.heightInTiles;	my++)
				{
					if (map.getTile(mx, my) == PLANTED_SOIL)
					{
						if (map.getTile(mx, my - 1) != 0)
							map.setTile(mx, my, 1); //suffocated seedlings die
						
						if(raining) tryGrowingTree(mx, my);
					}
					if (map.getTile(mx, my) == PLANTED_CLOUD)
					{
						if (map.getTile(mx, my - 1) != 0)
							map.setTile(mx, my, CLOUD); //suffocated seedlings die
						if(raining) tryGrowingTree(mx, my);
					}
				}
			
			
			
			//eject player from trees etc.
			while (map.getTile(int((avatar.x + 4) / 8), int((avatar.y + 4) / 8)) != 0)
				avatar.y -= 8;
			
		}
		
		public function addParticle(x:Number, y:Number, type:int, tiletype:int=0):void
		{
			var p:Particle = particles.getFirstAvailable() as Particle;
			if (p == null) {
				p = new Particle();
				particles.add(p);
			}
			p.init(x, y, type, tiletype);			
		}
		
		public function makeAmbientParticles():void
		{
			for (var mx:int = 0; mx < map.widthInTiles;	mx++)
				for (var my:int = 0; my < map.widthInTiles;	my++)
				{
					if (map.getTile(mx, my) == VOLCANO && map.getTile(mx, my-1) == 0)
						if (Math.random() < 0.3) addParticle(mx * 8 + 4 + Math.random(), my * 8 + 2, Particle.EMBER);
						
					if (map.getTile(mx, my) == WATER && map.getTile(mx, my-1) == 0)
						if (Math.random() < 0.05) addParticle(mx * 8 + Math.random()*7 + 0.5, my * 8 + 1 + Math.random()*2, Particle.WATER);
					
					if (map.getTile(mx, my) == DIAMOND)
						if (Math.random() < 0.05) addParticle(mx * 8 + Math.random()*6 + 1.5, my * 8 + 1 + Math.random()*4, Particle.WATER);
					
				}
			
			if (raining)
			{
				addParticle(Math.random() * FlxG.width, 0, Particle.RAIN);
			}
		}
		
		public function volcanoTouch(tile:FlxTile, object:FlxObject):void
		{
			if (tile.y >= avatar.y + 8 && !avatar.flickering)
			{
				avatar.flicker(1);
				avatar.velocity.y = -70;
				if (tile.x < avatar.x) avatar.velocity.x = 40;
				else avatar.velocity.x = -40;
				FlxG.play(ouchSound);
				charge_time = 0;
			}
		}
		
		public function smashTile(tx:int, ty:int):void
		{
			var tiletype:int = map.getTile(tx, ty);
			for (var i:int = 0; i < 6; i++)
				addParticle(tx * 8 + Math.random() * 7, ty * 8 + Math.random() * 7, Particle.DEBRIS, tiletype);
		}
		
		public function slam(tx:int, ty:int):Boolean
		{
			var top:int = map.getTile(tx, ty);
			var bottom:int = map.getTile(tx, ty + 1);
			
			trace("Slammed " + TILE_NAMES[top] + " onto " + TILE_NAMES[bottom]);
			
			if (bottom == 0) return true;
			
			if (top == DIAMOND) //diamond is harder than everything!
			{
				smashTile(tx, ty + 1);
				map.setTile(tx, ty, NOTHING);
				map.setTile(tx, ty + 1, DIAMOND);
				FlxG.play(slamSound);
				return true;
			}
			
			if (top == CLOUD) //broke cloud
			{
				for (i = 0; i < 15; i++)
					addParticle(tx * 8 - 4 + Math.random() * 16, ty * 8 - 4 + Math.random() * 16, Particle.SMOKE);
				map.setTile(tx, ty, NOTHING);
				FlxG.play(leavesSound);
				return true;
			}
			
			if (top == EMPTY_BOTTLE) // broke empty bottle
			{
				smashTile(tx, ty);
				map.setTile(tx, ty, 0);
				FlxG.play(glassSound);
				return true;
			}
			
			if (top == WATER_BOTTLE) // broke water bottle
			{
				smashTile(tx, ty);
				map.setTile(tx, ty, 10);
				FlxG.play(glassSound);
				return true;
			}
			
			if (top == POTION_BOTTLE) // broke potion bottle
			{
				if (bottom == DIRT)
				{
					map.setTile(tx, ty, NOTHING);
					map.setTile(tx, ty+1, GRASS); //dirt becomes grass!
					FlxG.play(alchemySound);
					addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
					return true;
				}
				if (bottom == LEAVES)
				{
					map.setTile(tx, ty, NOTHING);
					map.setTile(tx, ty+1, SKY_LEAVES); //leaves turn pink!
					FlxG.play(alchemySound);
					addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
					return true;
				}
				if (bottom == METAL)
				{
					map.setTile(tx, ty, NOTHING);
					map.setTile(tx, ty+1, GOLD); //alchemy!
					FlxG.play(alchemySound);
					addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
					return true;
				}
				
				if (bottom == PLANTED_SOIL)
				{
					map.setTile(tx, ty, NOTHING);
					if (tryGrowingTree(tx, ty + 1))
					{
						FlxG.play(alchemySound);
						addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
						map.setTile(tx, ty - 2, SKY_LEAVES);
						map.setTile(tx, ty - 3, SKY_LEAVES);
						map.setTile(tx - 1, ty - 2, SKY_LEAVES);
						map.setTile(tx+1, ty - 2, SKY_LEAVES);
						return true;
					}
					map.setTile(tx, ty, POTION_BOTTLE);
				}
				
				
				smashTile(tx, ty);
				map.setTile(tx, ty, CLOUD);
				FlxG.play(glassSound);
				return true;
			}
			
			
			
			if (bottom == VOLCANO && (top == WOOD || top == LEAVES || top == SEED || top == CRATE || top == SKY_LEAVES || top == CHEST)) //slammed plant matter onto volcano
			{
				smashTile(tx, ty);
				map.setTile(tx, ty, 0);
				for (var i:int = 0; i < 15; i++)
					addParticle(tx * 8 + Math.random() * 8, ty * 8 + Math.random() * 8, Particle.EMBER);
				for (i = 0; i < 8; i++)
					addParticle(tx * 8 + Math.random() * 8, ty * 8 + Math.random() * 8, Particle.SMOKE);
				
				FlxG.play(slamSound);
				return true;
			}
			if (bottom == VOLCANO && top == WATER)
			{
				for (i = 0; i < 15; i++)
					addParticle(tx * 8 - 4 + Math.random() * 16, ty * 8 - 4 + Math.random() * 16, Particle.SMOKE);
				map.setTile(tx, ty, CLOUD);
				FlxG.play(leavesSound);
				return true;
			}
			if (bottom == VOLCANO && top == GOLD)
			{
				map.setTile(tx, ty, KEY);
				FlxG.play(alchemySound);
				addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
				return true;
			}
			
			if (top == CRATE && bottom == CRATE) //crate + crate = treasure chest
			{
				map.setTile(tx, ty, NOTHING); //top crate vanish
				map.setTile(tx, ty+1, CHEST); //bottom chest
				FlxG.play(alchemySound);
				addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
				return true;
			}
			
			if (top == KEY && bottom == CHEST) //woot!
			{
				map.setTile(tx, ty, NOTHING); //key used
				smashTile(tx, ty + 1);
				map.setTile(tx, ty+1, DIAMOND); //chest opened
				FlxG.play(alchemySound);
				addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
				return true;
			}
			
			
			
			if (top == CRATE) //slamming a crate
			{
				/*if (bottom == VOLCANO)
				{
					smashTile(tx, ty);
					map.setTile(tx, ty, EMPTY_BOTTLE); //found a bottle!
					for (i = 0; i < 15; i++)
						addParticle(tx * 8 + Math.random() * 8, ty * 8 + Math.random() * 8, Particle.EMBER);
					for (i = 0; i < 8; i++)
						addParticle(tx * 8 + Math.random() * 8, ty * 8 + Math.random() * 8, Particle.SMOKE);		
					FlxG.play(slamSound);
					return true;
				}
				
				else*/
				{
					smashTile(tx, ty);
					map.setTile(tx, ty, EMPTY_BOTTLE); //broke a bottle!
					smashTile(tx, ty);
					map.setTile(tx, ty, 0);
					FlxG.play(glassSound);
					FlxG.play(slamSound);
					return true;
				}
				
			}
			
			if (top == LEAVES && bottom != NOTHING) //leaves slammed onto something
			{
				smashTile(tx, ty);
				map.setTile(tx, ty, SEED); //becomes seed
				FlxG.play(leavesSound);
				return true;
			}
			
			if (top == SKY_LEAVES && bottom != NOTHING) //leaves slammed onto something
			{
				if (bottom != WATER_BOTTLE)
				{
					smashTile(tx, ty);
					map.setTile(tx, ty, NOTHING); //becomes seed
					FlxG.play(leavesSound);
				}
				else
				{
					FlxG.play(alchemySound);
					map.setTile(tx, ty, NOTHING);
					addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
					map.setTile(tx, ty + 1, POTION_BOTTLE);
				}
				return true;
			}
			
			
			
			if (top == SEED &&( bottom == DIRT || bottom == GRASS)) //seed slammed onto dirt or grass
			{
				map.setTile(tx, ty, NOTHING); //seed becomes nothing
				map.setTile(tx, ty+1, PLANTED_SOIL); //ground becomes planted
				FlxG.play(alchemySound);
				addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
				return true;
			}
			
			if (top == SEED && bottom == CLOUD) //seed slammed onto cloud
			{
				map.setTile(tx, ty, NOTHING); //seed becomes nothing
				map.setTile(tx, ty+1, PLANTED_CLOUD); //cloud becomes planted
				FlxG.play(alchemySound);
				addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
				return true;
			}
			
			
			
			if (top == WOOD && bottom == WOOD) //wood + wood = crate
			{
				map.setTile(tx, ty, NOTHING); //top wood vanish
				map.setTile(tx, ty+1, CRATE); //bottom wood crate
				FlxG.play(alchemySound);
				addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
				return true;
			}
			
			
			
			
			
			if (top == WATER && bottom != NOTHING) //slammed water onto something
			{
				smashTile(tx, ty);
				map.setTile(tx, ty, NOTHING);
				FlxG.play(leavesSound);
				if (bottom == PLANTED_SOIL || bottom == PLANTED_CLOUD) //watered seedling
				{
					if (tryGrowingTree(tx, ty + 1))
					{
						FlxG.play(alchemySound);
						addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
					}
				}
				if (bottom == EMPTY_BOTTLE) //filled empty bottle
				{
					
						FlxG.play(alchemySound);
						addParticle(tx * 8 + 4, ty * 8, Particle.MAGIC);
						map.setTile(tx, ty + 1, WATER_BOTTLE);
				}
				return true;
			}
			
			return false;
		}
		
		
		
		public function tileUnderCursor(offX:int = 0, offY:int = 0):int
		{
			return map.getTile(int(cursor.x / 8) + offX, int(cursor.y / 8) + offY);
		}
		
		public function validAction():Boolean
		{
			if (int(cursor.x / 8) < 0) return false;
			if (int(cursor.x / 8) >= map.widthInTiles-1) return false;
			if (int(cursor.y / 8) < 0) return false;
			if (int(cursor.y / 8) >= map.heightInTiles) return false;	
			
			if (carrying == 0)
				return (tileUnderCursor() != 0);
			else
			{
				if (tileUnderCursor() != 0) return false;
				if (tileUnderCursor(0, 1) == 0 && 
					tileUnderCursor(0, -1) == 0 && 
					tileUnderCursor(1, 0) == 0 && 
					tileUnderCursor( -1, 0) == 0) return false;
					return true;
			}
			
		}
		
		public function takeTile():void
		{
			carrying = tileUnderCursor();
			map.setTile(int(cursor.x / 8), int(cursor.y / 8), 0);
			carried.frame = carrying;
			FlxG.play(grabSound);
			grabFrom.x = cursor.x;
			grabFrom.y = cursor.y;
			grab_frames = 0;
		}
		
		public function dropTile():void
		{
			map.setTile(int(cursor.x / 8), int(cursor.y / 8), carrying);
			carrying = 0;
			carried.frame = carrying;
			FlxG.play(dropSound);
		}
		
		
		private function updateCursor():void
		{
			cursor.x = avatar.x;
			if (avatar.facing == FlxObject.RIGHT) cursor.x += 12;
			else cursor.x -= 6;
			cursor.x = Math.floor(cursor.x / 8) * 8;
			
			cursor.y = avatar.y + 4;
			cursor.y = Math.floor(cursor.y / 8) * 8;
			
			var toPlayer:int;
			if (avatar.facing == FlxObject.RIGHT) toPlayer = -1; else toPlayer = 1;
			
			if (carrying != 0)
			{
				//cursor.y += 8;
				//if (tileUnderCursor() != 0 || tileUnderCursor(0, -1) != 0) cursor.y -= 8;
				//if (tileUnderCursor() != 0) cursor.y -= 8;	
				if (tileUnderCursor() == 0 && tileUnderCursor(0, 1) == 0) 
				{
					cursor.y += 8;
					if (!validAction()) cursor.y -= 8;
				}
				else if (tileUnderCursor() != 0 && tileUnderCursor(toPlayer, -1) == 0) cursor.y -= 8;
			}
			else
			{
				if (tileUnderCursor() == 0 && tileUnderCursor(0, 1) != 0) cursor.y += 8;
				//else if (tileUnderCursor() != 0 && tileUnderCursor(0, -1) != 0 && tileUnderCursor(toPlayer, -1) == 0) cursor.y -= 8;
				else if (tileUnderCursor() == 0 && tileUnderCursor(0, 1) == 0 && tileUnderCursor(0, -1) != 0) cursor.y -= 8;
			}
			
			if (validAction()) cursor.visible = true;
			else 
			{
				cursor.visible = false;
				charge_time = 0;
			}
			
			if (carrying == 0) cursor.frame = 0;
			else cursor.frame = 1;
		}
		
		private function manageCarrying():void
		{
			if(FlxG.keys.justPressed("X"))
			{
				if (carrying == 0)
				{
					if(validAction()) takeTile();
				}
				else
				{
					charging = true;
					charge_time = 0;
				}
			}
			if (FlxG.keys.justReleased("X"))
			{
				if (carrying != 0 && charging && validAction())
				{
					charging = false;
					dropTile();
					if (charge_time >= MAX_CHARGE_FRAMES)
					{
						
						var success:Boolean = slam(int(cursor.x / 8), int(cursor.y / 8));
						if (!success) 
						{
							FlxG.play(slamSound);
							for (var i:int = 0; i < 8; i++)
								addParticle(cursor.x + i, cursor.y + Math.random() + 7, Particle.SMOKE);
			
						}
						//FlxG.shake(0.01, 0.05);
					}
					else
					for (i = 0; i < 8; i++)
						addParticle(cursor.x + i, cursor.y + Math.random() + 7, Particle.SMOKE);
			
				}
			}
			cursor.color = 0xFFFFFFFF;
			if (FlxG.keys.X && charging) 
			{
				charge_time++;
				cursor.alpha = Math.min(Number(charge_time) / MAX_CHARGE_FRAMES, 1);
				
				if (charge_time == MAX_CHARGE_FRAMES) FlxG.play(chargedSound, 0.5);
				
				if (charge_time > MAX_CHARGE_FRAMES)
				{
					cursor.color = FlxColor.interpolateColor(0xFFFFFFCC, 0xFFFFCC00, 10, charge_time % 10);
				}
				
			}
			else cursor.alpha = 0.5;
			
			// do carried thing update
			if (grab_frames < MAX_GRAB_FRAMES)
			{
				carried.x = (grabFrom.x * (MAX_GRAB_FRAMES - grab_frames) + (avatar.x -1) * grab_frames) / MAX_GRAB_FRAMES;
				carried.y = (grabFrom.y * (MAX_GRAB_FRAMES - grab_frames) + (avatar.y - 8) * grab_frames) / MAX_GRAB_FRAMES;
				grab_frames++;
			}
			else
			{
			carried.x = avatar.x - 1;
			carried.y = avatar.y - 8;
			}
			carryText.text = TILE_NAMES[carrying];
		}
		
		override public function update():void
		{
			avatar.inWater = (map.getTile((avatar.x + 4) / 8, (avatar.y+6) / 8) == 10);
			super.update();
			FlxG.collide(avatar, map);
			
						
			//Move the cursor
			updateCursor();
			//handle pickup/drop actions
			
			manageCarrying();
			
			progressDay();
			
			if (raining && dayframes % 30 == 0) FlxG.play(rainSound);
			//if (FlxG.keys.justPressed("SPACE")) raining = true;// doDailyStuff();
			
			makeAmbientParticles();
		}
	}
}

