package  
{
	import org.flixel.*;
	
	/**
	 * ...
	 * @author Nathan McCoy
	 */
	public class PlayerSprite extends FlxSprite 
	{
		[Embed(source = "../lib/placeholderPlayerSprite.png")]
		private var image:Class;
		public var inWater:Boolean;
		private static const WATER_DRAG:Number = 0.90;
		
		public function PlayerSprite(X:Number=0, Y:Number=0) 
		{
			super(X, Y, image);
			loadGraphic(image, false, true);
			acceleration.y = 200;
			maxVelocity.y = 150;
			maxVelocity.x = 70;
			inWater = false;
			
		}
		public override function update():void
		{
			if ((FlxG.keys.Z || FlxG.keys.Y || FlxG.keys.W) && velocity.y < 0) acceleration.y = 200;
			else acceleration.y = 400;
			
			
			if (inWater) 
			{
				velocity.x *= WATER_DRAG;
				velocity.y *= WATER_DRAG;
				acceleration.y = 70;
			}
			
			
			if (touching & DOWN || inWater)
			{
				if (FlxG.keys.justPressed("Z") || FlxG.keys.justPressed("Y") || FlxG.keys.justPressed("W")) velocity.y = -90;
				acceleration.x = 0;
				if (FlxG.keys.LEFT) 
				{
					acceleration.x -= 300;
					facing = LEFT;
				}
				if (FlxG.keys.RIGHT)
				{
					acceleration.x += 300;
					facing = RIGHT;
				}
				drag.x = 300;
			}
			else
			{
				acceleration.x = 0;
				if (FlxG.keys.LEFT) 
				{
					acceleration.x -= 300;
					facing = LEFT;
				}
				if (FlxG.keys.RIGHT) 
				{
					acceleration.x += 300;
					facing = RIGHT;
				}
				drag.x = 100;
			}
			
			
			super.update();
			if (y > FlxG.height) y = -height-1;
			if (x < 0) x = 0;
			if (x > FlxG.width - width) x = FlxG.width - width;
		}
	}

}